Denis Vlasenko | 27e1501 | 2008-09-28 17:19:02 +0000 | [diff] [blame] | 1 | #!/bin/sh |
| 2 | |
Denys Vlasenko | ff0e875 | 2010-05-10 04:16:43 +0200 | [diff] [blame] | 3 | # If not specified in environment... |
| 4 | if ! test "$LIBC"; then |
| 5 | # Select which libc to build against |
| 6 | LIBC="glibc" |
| 7 | LIBC="uclibc" |
| 8 | fi |
Denis Vlasenko | 62e0dc2 | 2008-11-09 16:08:31 +0000 | [diff] [blame] | 9 | # x86 32-bit: |
Denys Vlasenko | ff0e875 | 2010-05-10 04:16:43 +0200 | [diff] [blame] | 10 | #CROSS_COMPILER_PREFIX="i486-linux-uclibc-" |
Denis Vlasenko | 62e0dc2 | 2008-11-09 16:08:31 +0000 | [diff] [blame] | 11 | # My system has strange prefix for x86 64-bit uclibc: |
Denys Vlasenko | ff0e875 | 2010-05-10 04:16:43 +0200 | [diff] [blame] | 12 | #CROSS_COMPILER_PREFIX="x86_64-pc-linux-gnu-" |
Denis Vlasenko | 27e1501 | 2008-09-28 17:19:02 +0000 | [diff] [blame] | 13 | |
Denys Vlasenko | ff0e875 | 2010-05-10 04:16:43 +0200 | [diff] [blame] | 14 | if test $# -lt 2 || ! test -d "$1" || test -e "$2"; then |
| 15 | echo "Usage: $0 SRC_DIR TMP_DIR" |
| 16 | echo |
| 17 | echo "SRC_DIR will be copied to TMP_DIR directory." |
| 18 | echo "Then a random build will be performed." |
| 19 | echo |
| 20 | echo "Useful variables:" |
| 21 | echo "\$LIBC, \$CROSS_COMPILER_PREFIX, \$MAKEOPTS" |
| 22 | exit 1 |
| 23 | fi |
Denis Vlasenko | 27e1501 | 2008-09-28 17:19:02 +0000 | [diff] [blame] | 24 | |
Denys Vlasenko | ff0e875 | 2010-05-10 04:16:43 +0200 | [diff] [blame] | 25 | cp -dpr -- "$1" "$2" || { echo "copy error"; exit 1; } |
| 26 | cd -- "$2" || { echo "cd $dir error"; exit 1; } |
Denis Vlasenko | 27e1501 | 2008-09-28 17:19:02 +0000 | [diff] [blame] | 27 | |
Denys Vlasenko | ff0e875 | 2010-05-10 04:16:43 +0200 | [diff] [blame] | 28 | # Generate random config |
| 29 | make randconfig >/dev/null || { echo "randconfig error"; exit 1; } |
Denis Vlasenko | 27e1501 | 2008-09-28 17:19:02 +0000 | [diff] [blame] | 30 | |
Denys Vlasenko | ff0e875 | 2010-05-10 04:16:43 +0200 | [diff] [blame] | 31 | # Tweak resulting config |
Denis Vlasenko | 27e1501 | 2008-09-28 17:19:02 +0000 | [diff] [blame] | 32 | cat .config \ |
Denys Vlasenko | ff0e875 | 2010-05-10 04:16:43 +0200 | [diff] [blame] | 33 | | grep -v CONFIG_DEBUG_PESSIMIZE \ |
Denis Vlasenko | 27e1501 | 2008-09-28 17:19:02 +0000 | [diff] [blame] | 34 | | grep -v CONFIG_WERROR \ |
Denys Vlasenko | ff0e875 | 2010-05-10 04:16:43 +0200 | [diff] [blame] | 35 | | grep -v CONFIG_CROSS_COMPILER_PREFIX \ |
Denys Vlasenko | 2315c88 | 2010-01-24 23:33:06 +0100 | [diff] [blame] | 36 | | grep -v CONFIG_SELINUX \ |
| 37 | | grep -v CONFIG_EFENCE \ |
| 38 | | grep -v CONFIG_DMALLOC \ |
Denys Vlasenko | ff0e875 | 2010-05-10 04:16:43 +0200 | [diff] [blame] | 39 | \ |
| 40 | | grep -v CONFIG_RFKILL \ |
| 41 | >.config.new |
Denis Vlasenko | 27e1501 | 2008-09-28 17:19:02 +0000 | [diff] [blame] | 42 | mv .config.new .config |
Denys Vlasenko | ff0e875 | 2010-05-10 04:16:43 +0200 | [diff] [blame] | 43 | echo '# CONFIG_DEBUG_PESSIMIZE is not set' >>.config |
| 44 | echo '# CONFIG_WERROR is not set' >>.config |
| 45 | echo "CONFIG_CROSS_COMPILER_PREFIX=\"${CROSS_COMPILER_PREFIX}\"" >>.config |
Denys Vlasenko | 3e5fa43 | 2010-07-06 02:26:35 +0200 | [diff] [blame] | 46 | echo '# CONFIG_SELINUX is not set' >>.config |
| 47 | echo '# CONFIG_EFENCE is not set' >>.config |
| 48 | echo '# CONFIG_DMALLOC is not set' >>.config |
| 49 | echo '# CONFIG_RFKILL is not set' >>.config |
Denis Vlasenko | 27e1501 | 2008-09-28 17:19:02 +0000 | [diff] [blame] | 50 | |
Denys Vlasenko | ff0e875 | 2010-05-10 04:16:43 +0200 | [diff] [blame] | 51 | # If glibc, don't build static |
| 52 | if test x"$LIBC" = x"glibc"; then |
| 53 | cat .config \ |
| 54 | | grep -v CONFIG_STATIC \ |
Denys Vlasenko | 015db58 | 2016-06-19 18:15:33 +0200 | [diff] [blame] | 55 | \ |
| 56 | | grep -v CONFIG_FEATURE_2_4_MODULES \ |
| 57 | | grep -v CONFIG_FEATURE_USE_BSS_TAIL \ |
| 58 | | grep -v CONFIG_DEBUG_SANITIZE \ |
Denys Vlasenko | ff0e875 | 2010-05-10 04:16:43 +0200 | [diff] [blame] | 59 | >.config.new |
| 60 | mv .config.new .config |
| 61 | echo '# CONFIG_STATIC is not set' >>.config |
Denys Vlasenko | 015db58 | 2016-06-19 18:15:33 +0200 | [diff] [blame] | 62 | # newer glibc (at least 2.23) no longer supply query_module() ABI. |
| 63 | # People who target 2.4 kernels would likely use older glibc (and older bbox). |
| 64 | echo '# CONFIG_FEATURE_2_4_MODULES is not set' >>.config |
| 65 | echo '# CONFIG_FEATURE_USE_BSS_TAIL is not set' >>.config |
| 66 | echo '# CONFIG_DEBUG_SANITIZE is not set' >>.config |
Denys Vlasenko | ff0e875 | 2010-05-10 04:16:43 +0200 | [diff] [blame] | 67 | fi |
Denis Vlasenko | 27e1501 | 2008-09-28 17:19:02 +0000 | [diff] [blame] | 68 | |
Denys Vlasenko | 3e5fa43 | 2010-07-06 02:26:35 +0200 | [diff] [blame] | 69 | # If uclibc, build static, and remove some things |
Denys Vlasenko | ff0e875 | 2010-05-10 04:16:43 +0200 | [diff] [blame] | 70 | # likely to not work on uclibc. |
| 71 | if test x"$LIBC" = x"uclibc"; then |
| 72 | cat .config \ |
| 73 | | grep -v CONFIG_STATIC \ |
| 74 | | grep -v CONFIG_BUILD_LIBBUSYBOX \ |
Denys Vlasenko | ff0e875 | 2010-05-10 04:16:43 +0200 | [diff] [blame] | 75 | | grep -v CONFIG_PIE \ |
Denys Vlasenko | 3e5fa43 | 2010-07-06 02:26:35 +0200 | [diff] [blame] | 76 | \ |
| 77 | | grep -v CONFIG_FEATURE_2_4_MODULES \ |
Denys Vlasenko | 69c8c69 | 2015-10-11 16:27:55 +0200 | [diff] [blame] | 78 | | grep -v CONFIG_FEATURE_SYNC_FANCY \ |
| 79 | | grep -v CONFIG_FEATURE_TOUCH_NODEREF \ |
Denys Vlasenko | 015db58 | 2016-06-19 18:15:33 +0200 | [diff] [blame] | 80 | | grep -v CONFIG_NANDWRITE \ |
| 81 | | grep -v CONFIG_NANDDUMP \ |
| 82 | | grep -v CONFIG_BLKDISCARD \ |
| 83 | | grep -v CONFIG_NSENTER \ |
| 84 | | grep -v CONFIG_UNSHARE \ |
Denys Vlasenko | 7fdb764 | 2017-07-03 02:33:08 +0200 | [diff] [blame^] | 85 | | grep -v CONFIG_FALLOCATE \ |
| 86 | | grep -v CONFIG_UDHCPC6 \ |
| 87 | | grep -v CONFIG_ASH_INTERNAL_GLOB \ |
Denys Vlasenko | ff0e875 | 2010-05-10 04:16:43 +0200 | [diff] [blame] | 88 | >.config.new |
| 89 | mv .config.new .config |
| 90 | echo 'CONFIG_STATIC=y' >>.config |
Denys Vlasenko | 3e5fa43 | 2010-07-06 02:26:35 +0200 | [diff] [blame] | 91 | echo '# CONFIG_BUILD_LIBBUSYBOX is not set' >>.config |
| 92 | echo '# CONFIG_PIE is not set' >>.config |
| 93 | echo '# CONFIG_FEATURE_2_4_MODULES is not set' >>.config |
Denys Vlasenko | 69c8c69 | 2015-10-11 16:27:55 +0200 | [diff] [blame] | 94 | echo '# CONFIG_FEATURE_SYNC_FANCY is not set' >>.config |
Denys Vlasenko | 198b02f | 2013-12-31 23:22:36 +0100 | [diff] [blame] | 95 | echo '# CONFIG_FEATURE_TOUCH_NODEREF is not set' >>.config |
Denys Vlasenko | 015db58 | 2016-06-19 18:15:33 +0200 | [diff] [blame] | 96 | # My uclibc installation does not support some needed APIs... |
| 97 | echo '# CONFIG_NANDWRITE is not set' >>.config |
| 98 | echo '# CONFIG_NANDDUMP is not set' >>.config |
| 99 | echo '# CONFIG_BLKDISCARD is not set' >>.config |
| 100 | echo '# CONFIG_NSENTER is not set' >>.config |
| 101 | echo '# CONFIG_UNSHARE is not set' >>.config |
Denys Vlasenko | 7fdb764 | 2017-07-03 02:33:08 +0200 | [diff] [blame^] | 102 | echo '# CONFIG_FALLOCATE is not set' >>.config |
| 103 | echo '# CONFIG_UDHCPC6 is not set' >>.config |
| 104 | echo 'CONFIG_ASH_INTERNAL_GLOB=y' >>.config |
Denys Vlasenko | ff0e875 | 2010-05-10 04:16:43 +0200 | [diff] [blame] | 105 | fi |
| 106 | |
| 107 | # If STATIC, remove some things. |
Denis Vlasenko | 27e1501 | 2008-09-28 17:19:02 +0000 | [diff] [blame] | 108 | # PAM with static linking is probably pointless |
| 109 | # (but I need to try - now I don't have libpam.a on my system, only libpam.so) |
Denys Vlasenko | ff0e875 | 2010-05-10 04:16:43 +0200 | [diff] [blame] | 110 | if grep -q "^CONFIG_STATIC=y" .config; then |
| 111 | cat .config \ |
| 112 | | grep -v CONFIG_PAM \ |
| 113 | >.config.new |
| 114 | mv .config.new .config |
Denys Vlasenko | 3e5fa43 | 2010-07-06 02:26:35 +0200 | [diff] [blame] | 115 | echo '# CONFIG_PAM is not set' >>.config |
Denys Vlasenko | ff0e875 | 2010-05-10 04:16:43 +0200 | [diff] [blame] | 116 | fi |
Denis Vlasenko | 27e1501 | 2008-09-28 17:19:02 +0000 | [diff] [blame] | 117 | |
Denis Vlasenko | 27e1501 | 2008-09-28 17:19:02 +0000 | [diff] [blame] | 118 | # Regenerate .config with default answers for yanked-off options |
Denys Vlasenko | ff0e875 | 2010-05-10 04:16:43 +0200 | [diff] [blame] | 119 | # (most of default answers are "no"). |
| 120 | { yes "" | make oldconfig >/dev/null; } || { echo "oldconfig error"; exit 1; } |
Denis Vlasenko | 27e1501 | 2008-09-28 17:19:02 +0000 | [diff] [blame] | 121 | |
Denys Vlasenko | ff0e875 | 2010-05-10 04:16:43 +0200 | [diff] [blame] | 122 | # Build! |
| 123 | nice -n 10 make $MAKEOPTS 2>&1 | tee make.log |
Denys Vlasenko | bb0bf28 | 2016-06-19 21:54:04 +0200 | [diff] [blame] | 124 | grep 'Rerun make' make.log \ |
| 125 | && nice -n 10 make $MAKEOPTS 2>&1 | tee -a make.log |
Denis Vlasenko | 27e1501 | 2008-09-28 17:19:02 +0000 | [diff] [blame] | 126 | |
Denys Vlasenko | ff0e875 | 2010-05-10 04:16:43 +0200 | [diff] [blame] | 127 | # Return exitcode 1 if busybox executable does not exist |
| 128 | test -x busybox |